Back to home page

EIC code displayed by LXR

 
 

    


File indexing completed on 2025-01-18 10:03:16

0001 // Created on: 1993-07-22
0002 // Created by: Remi LEQUETTE
0003 // Copyright (c) 1993-1999 Matra Datavision
0004 // Copyright (c) 1999-2014 OPEN CASCADE SAS
0005 //
0006 // This file is part of Open CASCADE Technology software library.
0007 //
0008 // This library is free software; you can redistribute it and/or modify it under
0009 // the terms of the GNU Lesser General Public License version 2.1 as published
0010 // by the Free Software Foundation, with special exception defined in the file
0011 // OCCT_LGPL_EXCEPTION.txt. Consult the file LICENSE_LGPL_21.txt included in OCCT
0012 // distribution for complete text of the license and disclaimer of any warranty.
0013 //
0014 // Alternatively, this file may be used under the terms of Open CASCADE
0015 // commercial license or contractual agreement.
0016 
0017 #ifndef _BRepPrimAPI_MakeSphere_HeaderFile
0018 #define _BRepPrimAPI_MakeSphere_HeaderFile
0019 
0020 #include <Standard.hxx>
0021 #include <Standard_DefineAlloc.hxx>
0022 
0023 #include <BRepPrim_Sphere.hxx>
0024 #include <BRepPrimAPI_MakeOneAxis.hxx>
0025 class gp_Pnt;
0026 class gp_Ax2;
0027 
0028 
0029 //! Describes functions to build spheres or portions of spheres.
0030 //! A MakeSphere object provides a framework for:
0031 //! -   defining the construction of a sphere,
0032 //! -   implementing the construction algorithm, and
0033 //! -   consulting the result.
0034 class BRepPrimAPI_MakeSphere  : public BRepPrimAPI_MakeOneAxis
0035 {
0036 public:
0037 
0038   DEFINE_STANDARD_ALLOC
0039 
0040   
0041   //! Make a sphere.
0042   //! @param R [in] sphere radius
0043   Standard_EXPORT BRepPrimAPI_MakeSphere(const Standard_Real R);
0044 
0045   //! Make a sphere (spherical wedge).
0046   //! @param R     [in] sphere radius
0047   //! @param angle [in] angle between the radii lying within the bounding semidisks
0048   Standard_EXPORT BRepPrimAPI_MakeSphere(const Standard_Real R, const Standard_Real angle);
0049 
0050   //! Make a sphere (spherical segment).
0051   //! @param R [in] sphere radius
0052   //! @param angle1 [in] first angle defining a spherical segment
0053   //! @param angle2 [in] second angle defining a spherical segment
0054   Standard_EXPORT BRepPrimAPI_MakeSphere(const Standard_Real R, const Standard_Real angle1, const Standard_Real angle2);
0055 
0056   //! Make a sphere (spherical segment).
0057   //! @param R      [in] sphere radius
0058   //! @param angle1 [in] first angle defining a spherical segment
0059   //! @param angle2 [in] second angle defining a spherical segment
0060   //! @param angle3 [in] angle between the radii lying within the bounding semidisks
0061   Standard_EXPORT BRepPrimAPI_MakeSphere(const Standard_Real R, const Standard_Real angle1, const Standard_Real angle2, const Standard_Real angle3);
0062 
0063   //! Make a sphere.
0064   //! @param Center [in] sphere center coordinates
0065   //! @param R      [in] sphere radius
0066   Standard_EXPORT BRepPrimAPI_MakeSphere(const gp_Pnt& Center, const Standard_Real R);
0067   
0068   //! Make a sphere (spherical wedge).
0069   //! @param Center [in] sphere center coordinates
0070   //! @param R      [in] sphere radius
0071   //! @param angle  [in] angle between the radii lying within the bounding semidisks
0072   Standard_EXPORT BRepPrimAPI_MakeSphere(const gp_Pnt& Center, const Standard_Real R, const Standard_Real angle);
0073 
0074   //! Make a sphere (spherical segment).
0075   //! @param Center [in] sphere center coordinates
0076   //! @param R      [in] sphere radius
0077   //! @param angle1 [in] first angle defining a spherical segment
0078   //! @param angle2 [in] second angle defining a spherical segment
0079   Standard_EXPORT BRepPrimAPI_MakeSphere(const gp_Pnt& Center, const Standard_Real R, const Standard_Real angle1, const Standard_Real angle2);
0080 
0081   //! Make a sphere (spherical segment).
0082   //! @param Center [in] sphere center coordinates
0083   //! @param R      [in] sphere radius
0084   //! @param angle1 [in] first angle defining a spherical segment
0085   //! @param angle2 [in] second angle defining a spherical segment
0086   //! @param angle3 [in] angle between the radii lying within the bounding semidisks
0087   Standard_EXPORT BRepPrimAPI_MakeSphere(const gp_Pnt& Center, const Standard_Real R, const Standard_Real angle1, const Standard_Real angle2, const Standard_Real angle3);
0088 
0089   //! Make a sphere.
0090   //! @param Axis [in] coordinate system for the construction of the sphere
0091   //! @param R    [in] sphere radius
0092   Standard_EXPORT BRepPrimAPI_MakeSphere(const gp_Ax2& Axis, const Standard_Real R);
0093 
0094   //! Make a sphere (spherical wedge).
0095   //! @param Axis  [in] coordinate system for the construction of the sphere
0096   //! @param R     [in] sphere radius
0097   //! @param angle [in] angle between the radii lying within the bounding semidisks
0098   Standard_EXPORT BRepPrimAPI_MakeSphere(const gp_Ax2& Axis, const Standard_Real R, const Standard_Real angle);
0099 
0100   //! Make a sphere (spherical segment).
0101   //! @param Axis   [in] coordinate system for the construction of the sphere
0102   //! @param R      [in] sphere radius
0103   //! @param angle1 [in] first angle defining a spherical segment
0104   //! @param angle2 [in] second angle defining a spherical segment
0105   Standard_EXPORT BRepPrimAPI_MakeSphere(const gp_Ax2& Axis, const Standard_Real R, const Standard_Real angle1, const Standard_Real angle2);
0106 
0107   //! Make a sphere of radius R.
0108   //! For all algorithms The resulting shape is composed of
0109   //! -   a lateral spherical face,
0110   //! -   two planar faces parallel to the plane z = 0 if the
0111   //! sphere is truncated in the v parametric direction, or
0112   //! only one planar face if angle1 is equal to -p/2 or if
0113   //! angle2 is equal to p/2 (these faces are circles in
0114   //! case of a complete truncated sphere),
0115   //! -   and in case of a portion of sphere, two planar faces
0116   //! to shut the shape.(in the planes u = 0 and u = angle).
0117   Standard_EXPORT BRepPrimAPI_MakeSphere(const gp_Ax2& Axis, const Standard_Real R, const Standard_Real angle1, const Standard_Real angle2, const Standard_Real angle3);
0118   
0119   //! Returns the algorithm.
0120   Standard_EXPORT Standard_Address OneAxis();
0121   
0122   //! Returns the algorithm.
0123   Standard_EXPORT BRepPrim_Sphere& Sphere();
0124 
0125 
0126 
0127 
0128 protected:
0129 
0130 
0131 
0132 
0133 
0134 private:
0135 
0136 
0137 
0138   BRepPrim_Sphere mySphere;
0139 
0140 
0141 };
0142 
0143 
0144 
0145 
0146 
0147 
0148 
0149 #endif // _BRepPrimAPI_MakeSphere_HeaderFile